clear; clc;clf;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Opgave 3  
% Radial acceleration (Principal Component Analysis)
%
% velser: Morten Dam Jrgensen, 2011, http://mdj.dk
% Datast: Tak til Allan Hansen og ko.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% 3.1
%
% Indls datasttet "ipod_4.txt"
%
% - De fire variable er hhv. acceleration langs x, y og z akserne samt tid
% i sekunder.
%

data = importdata('ipod_4.txt')

% 3.2
% Plot de tre accelerationskomponenter som funktion af tiden.
%

figure(1)
subplot(3,1,1)
plot(data(:,4), data(:,1))
xlabel('acceleration x-akse (g)')

subplot(3,1,2)
plot(data(:,4), data(:,2))
xlabel('acceleration y-akse (g)')

subplot(3,1,3)
plot(data(:,4), data(:,3))
xlabel('acceleration z-akse (g)')


% PCA Algoritme: start

% 3.3
% Find de dominerede komponenter, ved at benytte PCA metoden beskriver i
% velsesvejledningen (afsnit 2).
%
% 3.3.1
% Transponer input matricen sdan at M x N, hvor M svarer til antallet af
% parametre og N antallet af mlinger.
% 

dat = data';

[M N] = size(dat)

% 3.3.2
% Centrer dataen ved frst at beregne middelvrdien for de fire parametre,
% og fratrk denne de enkelte komponenter
% Hint: data_center = data - repmat(middelvrdierne, 1, antallet_af_mlinger)
m = mean(dat,2)

dat = dat - repmat(m, 1, N);

% 3.3.3
% Beregn kovariansmatricen af den centrerede data
%
cor = cov(dat');
% 3.3.4
% Beregn egenvrdierne og egenvektorerne af kovariansmatricen, med den
% indbyggede funktion i MATLAB.
%

[V E] = eig(cor);
% 3.3.5
% Gem diagonalen af egenvrdimatricen i en vektor (M x 1)
%

eval = diag(E);

% 3.3.6
% Sorter egenvrdierne efter faldende orden, og gem de indexer som
% sorteringsmetoden retunerer i en vektor.
% Hint: [smidvk indices] = sort(egenvrdier, 'descend')
%

[drop indices] = sort(eval, 'descend');

% 3.3.7
% Sorter egenvektorerne og egenvrdierne med index-vektoren
% Hint: egenvec = egenvec(:,indices); egenvrdier = egenvrdier(indices)

egvec = V(:, indices);
eval = eval(indices);

% 3.3.8 
% Projekter den oprindelige data langs den nye basis (egenvektor matricen)
% Hint: data_pca = egenvec' * data

data_pca = egvec' * dat;
%% Plotting

%
% 3.4
% Plot hvert komponent af det transformerede datast som funktion af tiden.
% 
% - Ved at sammenligne vrdierne fra egenvektorne med de fire plots,
% forklar hvad de enkelte komponenter beskriver.
%

figure(2)
subplot(4,1,1)
plot(data(:,4), data_pca(1, :))
xlabel('1. Komponent')

subplot(4,1,2)
plot(data(:,4), data_pca(2, :))
xlabel('2. Komponent')

subplot(4,1,3)
plot(data(:,4), data_pca(3, :))
xlabel('3. Komponent')


subplot(4,1,4)
plot(data(:,4), data_pca(4, :))
xlabel('4. Komponent')


% 3.5 (frivillig!)
% Benyt MATLABs indbyggede pca routiner
% 
% [C, latent, explained] = pcacov(cov(data'))
% biplot(egenvec(:,1:2), 'scores', signals(1:2,:)', 'varlabels',datalabels)
%

[C, latent, explained] = pcacov(cov(data))

figure(3)
datalabels = char('x','y','z','t');
biplot(egvec(:,1:2), 'scores', dat(1:2,:)', 'varlabels',datalabels)


% 3.6 (frivillig!)
%
% PCA teknikken afhnger af linere relationer mellem de forskellige
% variable, der findes en anden metode til ikke-linere data, der benytte
% det skaldte "kernel-kneb".
% I zip-filen medflger en funktion kaldet "kernelpca_tutorial.m", gentag
% opgave 3.5 for resultatet fra funktionen. 
%
% Mere info: http://en.wikipedia.org/wiki/Kernel_principal_component_analysis
%

data_kpca = kernelpca_tutorial(data', 4);

figure(4)
subplot(4,1,1)
plot(data(:,4), data_kpca(1, :))
xlabel('1. Komponent')

subplot(4,1,2)
plot(data(:,4), data_kpca(2, :))
xlabel('2. Komponent')

subplot(4,1,3)
plot(data(:,4), data_kpca(3, :))
xlabel('3. Komponent')


subplot(4,1,4)
plot(data(:,4), data_kpca(4, :))
xlabel('4. Komponent')

